Setting tag bootcd-5.0-8
[bootcd.git] / build.sh
index 7964a1d..c623745 100755 (executable)
--- a/build.sh
+++ b/build.sh
 #!/bin/bash
 #
 # Builds custom BootCD ISO and USB images in the current
-# directory. For backward compatibility, if an old-style static
-# configuration is specified, that configuration file will be parsed
-# instead of the current PLC configuration in
-# /etc/planetlab/plc_config.
+# directory. 
 #
 # Aaron Klingaman <alk@absarokasoft.com>
 # Mark Huang <mlhuang@cs.princeton.edu>
 # Copyright (C) 2004-2007 The Trustees of Princeton University
 #
-# $Id$
-#
 
+COMMAND=$(basename $0)
+DIRNAME=$(dirname $0)
 PATH=/sbin:/bin:/usr/sbin:/usr/bin
 
-CONFIGURATION=default
-NODE_CONFIGURATION_FILE=
-TYPES="usb iso usb_serial iso_serial"
+# defaults
+DEFAULT_TYPES="usb iso"
 # Leave 4 MB of free space
+GRAPHIC_CONSOLE="graphic"
+SERIAL_CONSOLE="ttyS0:115200:n:8"
+CONSOLE_INFO=$GRAPHIC_CONSOLE
+MKISOFS_OPTS="-R -J -r -f -b isolinux.bin -c boot.cat -no-emul-boot -boot-load-size 4 -boot-info-table"
 FREE_SPACE=4096
+
+# command-line settable args
+NODE_CONFIGURATION_FILE=
 CUSTOM_DIR=
 OUTPUT_BASE=
-MKISOFS_OPTS="-R -J -r -f -b isolinux.bin -c boot.cat -no-emul-boot -boot-load-size 4 -boot-info-table"
+DRY_RUN=""
+OUTPUT_NAME=""
+TYPES=""
+KARGS_STR=""
+
+# various globals
+BUILDTMP=""
+FULL_VERSION_STRING=""
+ISOREF=""
+ISOFS=""
+OVERLAY=""
+IS_SERIAL=""
+console_dev=""
+console_baud=""
+console_spec=""
+console_serial_line=""
+kernel_args=""
+
+
+#################### compute all supported types
+# removing support for serial in the type
+# this is because kargs.txt goes in the overlay, that is computed only once
+# so we cannot handle serial and graphic modes within the same invokation of this script
+
+ALL_TYPES=""
+for x in iso usb usb_partition; do for c in "" "_cramfs" ; do
+  t="${x}${c}"
+  case $t in
+      usb_partition_cramfs)
+         # unsupported
+         ;;
+      *)
+         ALL_TYPES="$ALL_TYPES $t" ;;
+  esac
+done; done
+
+#################### cleanup utilities
+declare -a _CLEANUPS=()
+function do_cleanup() {
+    cd / ; for i in "${_CLEANUPS[@]}"; do $i ; done
+}
+function push_cleanup() {
+    _CLEANUPS=( "${_CLEANUPS[@]}" "$*" )
+}
+function pop_cleanup() {
+    unset _CLEANUPS[$((${#_CLEANUPS[@]} - 1))]
+}
 
-usage()
-{
-    echo "Usage: build.sh [OPTION]..."
-    echo "    -c name          (Deprecated) Static configuration to use (default: $CONFIGURATION)"
-    echo "    -f planet.cnf    Node to customize CD for (default: none)"
-    echo "    -t 'types'       Build the specified images (default: $TYPES)"
-    echo "    -a               Build all supported images"
+#################### initialization
+function init_and_check () {
+
+    # Change to our source directory
+    local srcdir=$(cd $DIRNAME && pwd -P)
+    pushd $srcdir
+
+    # Root of the isofs
+    ISOREF=$PWD/${VARIANT}
+
+    # The reference image is expected to have been built by prep.sh (see .spec)
+    # we disable the initial logic that called prep.sh if that was not the case
+    # this is because prep.sh needs to know pldistro 
+    if [ ! -f $ISOREF/isofs/bootcd.img -o ! -f $ISOREF/version.txt ] ; then
+       echo "Could not find isofs and version.txt in $ISOREF"
+       if [ "$VARIANT" == "build" ] ; then
+           echo "You have to run prep.sh prior to calling $COMMAND"
+       else
+           echo "You need to create your variant image, see kvariant.sh"
+       fi
+       echo "Exiting .."
+       exit 1
+    fi
+
+    # build/version.txt written by prep.sh
+    BOOTCD_VERSION=$(cat ${VARIANT}/version.txt)
+
+    if [ -f /etc/planetlab/plc_config ] ; then
+        # Source PLC configuration
+       . /etc/planetlab/plc_config
+    fi
+
+    # use /var/tmp that should be large enough on both chroot- or vserver-based myplc
+    BUILDTMP=/var/tmp
+
+    FULL_VERSION_STRING="${PLC_NAME} BootCD ${BOOTCD_VERSION}"
+
+}
+
+# NOTE
+# the custom-dir feature is designed to let a myplc try/ship a patched bootcd
+# without the need for a full devel environment
+# for example, you would create /root/custom-bootcd/etc/rc.d/init.d/pl_hwinit
+# and run this script with -C /root/custom-bootcd
+# this creates a third .img image of the custom dir, that 'hides' the files from 
+# bootcd.img in the resulting unionfs
+# it seems that this feature has not been used nor tested in a long time, use with care
+
+usage() {
+    echo "Usage: $COMMAND [OPTION]..."
+    echo "    -f plnode.txt    Node to customize CD for (default: none)"
+    echo "    -t 'types'       Build the specified images (default: $DEFAULT_TYPES)"
+    echo "                     NOTE: mentioning 'serial' as part of the type is not supported anymore"
+    echo "    -a               Build all known types as listed below"
+    echo "    -s console-info  Enable a serial line as console and also bring up getty on that line"
+    echo "                     console-info: tty:baud-rate:parity:bits"
+    echo "                     or 'default' shortcut for $SERIAL_CONSOLE"
+    echo "    -S               equivalent to -s default"
+    echo "    -O output-base   The prefix of the generated files (default: PLC_NAME-BootCD-VERSION)"
+    echo "                     useful when multiple types are provided"
+    echo "                     can be a full path"
+    echo "    -o output-name   The full name of the generated file"
     echo "    -C custom-dir    Custom directory"
-    echo "    -O output-base   The basename of the generated files (default: PLC_NAME-BootCD-VERSION)"
+    echo "    -V variant       Use a variant - see kvariant.sh"
+    echo "    -n               Dry run - mostly for debug/test purposes"
+    echo "    -k               Add additional parameters to the kargs.txt file"
     echo "    -h               This message"
+    echo "All known types: $ALL_TYPES"
     exit 1
 }
 
-# Get options
-while getopts "O:c:f:t:C:ah" opt ; do
-    case $opt in
-    c)
-        CONFIGURATION=$OPTARG
-        ;;
-    f)
-        NODE_CONFIGURATION_FILE=$OPTARG
-        ;;
-    t)
-        TYPES="$OPTARG"
-        ;;
-    C)
-        CUSTOM_DIR="$OPTARG"
-        ;;
-    O)
-        OUTPUT_BASE="$OPTARG"
-        ;;
-    a)
-        TYPES="usb iso usb_serial iso_serial usb_cramfs iso_cramfs usb_cramfs_serial iso_cramfs_serial"
-        ;;
-    h|*)
-        usage
-        ;;
-    esac
-done
-
-# Do not tolerate errors
-set -e
-
-# Change to our source directory
-srcdir=$(cd $(dirname $0) && pwd -P)
-pushd $srcdir
-
-# Root of the isofs
-isofs=$PWD/build/isofs
-
-# The reference image is expected to have been built by prep.sh (see .spec)
-# we disable the initial logic that called prep.sh if that was not the case
-# this is because prep.sh needs to know pldistro 
-if [ ! -f $isofs/bootcd.img -o ! -f build/version.txt ] ; then
-    echo "You have to run prep.sh prior to calling $0 - exiting"
-    exit 1
-fi
-
-# build/version.txt written by prep.sh
-BOOTCD_VERSION=$(cat build/version.txt)
-
-if [ -f /etc/planetlab/plc_config ] ; then
-    # Source PLC configuration
-    . /etc/planetlab/plc_config
-fi
-
-### This support for backwards compatibility can be taken out in the
-### future. RC1 based MyPLCs set $PLC_BOOT_SSL_CRT in the plc_config
-### file, but >=RC2 based bootcd assumes that $PLC_BOOT_CA_SSL_CRT is
-### set.
-if [ -z "$PLC_BOOT_CA_SSL_CRT" -a ! -z "$PLC_BOOT_SSL_CRT" ] ; then
-    PLC_BOOT_CA_SSL_CRT=$PLC_BOOT_SSL_CRT
-fi
-
-# If PLC configuration is not valid, try a static configuration
-if [ -z "$PLC_BOOT_CA_SSL_CRT" -a -d configurations/$CONFIGURATION ] ; then
-    # (Deprecated) Source static configuration
-    . configurations/$CONFIGURATION/configuration
-    PLC_NAME="PlanetLab"
-    PLC_MAIL_SUPPORT_ADDRESS="support@planet-lab.org"
-    PLC_WWW_HOST="www.planet-lab.org"
-    PLC_WWW_PORT=80
-    if [ -n "$EXTRA_VERSION" ] ; then
-    BOOTCD_VERSION="$BOOTCD_VERSION $EXTRA_VERSION"
-    fi
-    PLC_BOOT_HOST=$PRIMARY_SERVER
-    PLC_BOOT_SSL_PORT=$PRIMARY_SERVER_PORT
-    PLC_BOOT_CA_SSL_CRT=configurations/$CONFIGURATION/$PRIMARY_SERVER_CERT
-    PLC_ROOT_GPG_KEY_PUB=configurations/$CONFIGURATION/$PRIMARY_SERVER_GPG
-fi
-
-FULL_VERSION_STRING="$PLC_NAME BootCD $BOOTCD_VERSION"
-
-echo "* Building images for $FULL_VERSION_STRING"
-
-# From within a myplc chroot /usr/tmp is too small 
-# to build all possible images, whereas /data is part of the host
-# filesystem and usually has sufficient space.  What we
-# should do is check whether the expected amount of space
-# is available.
-BUILDTMP=/usr/tmp
-if [ -d /data/tmp ] ; then
-    isreadonly=$(mktemp /data/tmp/isreadonly.XXXXXX || /bin/true)
-    if [ -n "$isreadonly" ] ; then
-        rm -f "$isreadonly"
-        BUILDTMP=/data/tmp
+#################### 
+function parse_command_line () {
+
+    # init
+    TYPES=""
+    # Get options
+    while getopts "f:t:as:SO:o:C:V:k:nh" opt ; do
+       case $opt in
+           f) NODE_CONFIGURATION_FILE=$OPTARG ;;
+           t) TYPES="$TYPES $OPTARG" ;;
+           a) TYPES="$ALL_TYPES" ;;
+           s) CONSOLE_INFO="$OPTARG" ;;
+           S) CONSOLE_INFO=$SERIAL_CONSOLE ;;
+           O) OUTPUT_BASE="$OPTARG" ;;
+           o) OUTPUT_NAME="$OPTARG" ;;
+           C) CUSTOM_DIR="$OPTARG" ;;
+           V) VARIANT="$OPTARG" ;;
+           k) KARGS_STR="$KARGS_STR $OPTARG" ;;
+           n) DRY_RUN=true ;;
+           h|*) usage ;;
+       esac
+    done
+
+    # use defaults if not set
+    [ -z "$TYPES" ] && TYPES="$DEFAULT_TYPES"
+    [ -z "$VARIANT" ] && VARIANT="build"
+    [ "$CONSOLE_INFO" == "default" ] && CONSOLE_INFO=$SERIAL_CONSOLE
+
+    if [ -n "$NODE_CONFIGURATION_FILE" ] ; then
+    # check existence of NODE_CONFIGURATION_FILE and normalize as we will change directory
+       if [ ! -f "$NODE_CONFIGURATION_FILE" ] ; then
+           echo "Node configuration file $NODE_CONFIGURATION_FILE not found - exiting"
+           exit 1
+       fi
+       cf_dir="$(dirname $NODE_CONFIGURATION_FILE)"
+       cf_dir="$(cd $cf_dir; pwd -P)"
+       cf_file="$(basename $NODE_CONFIGURATION_FILE)"
+       NODE_CONFIGURATION_FILE="$cf_dir"/"$cf_file"
     fi
-fi
 
-declare -a _CLEANUPS=()
-function do_cleanup()
-{
-    cd /
-    for i in "${_CLEANUPS[@]}"; do
-        $i
+    # check TYPES 
+    local matcher="XXX$(echo $ALL_TYPES | sed -e 's,\W,XXX,g')XXX"
+    for t in $TYPES; do
+       echo Checking type $t
+       echo $matcher | grep XXX${t}XXX &> /dev/null
+       if [ "$?" != 0 ] ; then
+           echo Unknown type $t
+           usage
+       fi
     done
+
 }
-function push_cleanup()
-{
-    _CLEANUPS=( "${_CLEANUPS[@]}" "$*" )
-}
-function pop_cleanup()
-{
-    unset _CLEANUPS[$((${#_CLEANUPS[@]} - 1))]
+
+####################
+function init_serial () {
+    local console=$1; shift
+    if [ "$console" == "$GRAPHIC_CONSOLE" ] ; then
+       IS_SERIAL=
+       console_spec=""
+       echo "Standard, graphic, non-serial mode"
+    else
+       IS_SERIAL=true
+       console_dev=$(echo "$console" | awk -F: ' {print $1}')
+       console_baud=$(echo "$console" | awk -F: ' {print $2}')
+       [ -z "$console_baud" ] && console_baud="115200"
+       local console_parity=$(echo "$console" | awk -F: ' {print $3}')
+       [ -z "$console_parity" ] && console_parity="n"
+       local console_bits=$(echo "$console" | awk -F: ' {print $4}')
+       [ -z "$console_bits" ] && console_bits="8"
+       console_spec="console=${console_dev},${console_baud}${console_parity}${console_bits}"
+       local tty_nb=$(echo $console_dev | sed -e 's,[a-zA-Z],,g')
+       console_serial_line="SERIAL ${tty_nb} ${console_baud}"
+       echo "Serial mode"
+       echo "console_serial_line=${console_serial_line}"
+       echo "console_spec=${console_spec}"
+    fi
 }
 
-trap "do_cleanup" ERR INT EXIT
-
-BUILDTMP=$(mktemp -d ${BUILDTMP}/bootcd.XXXXXX)
-push_cleanup rm -fr "${BUILDTMP}"
-mkdir "${BUILDTMP}/isofs"
-for i in "$isofs"/{bootcd.img,kernel}; do
-    ln -s "$i" "${BUILDTMP}/isofs"
-done
-cp "$isofs/isolinux.bin" "${BUILDTMP}/isofs"
-isofs="${BUILDTMP}/isofs"
-
-# Root of the ISO and USB images
-echo "* Populating root filesystem..."
-overlay="${BUILDTMP}/overlay"
-install -d -m 755 $overlay
-push_cleanup rm -fr $overlay
-
-# Create version files
-echo "* Creating version files"
-
-# Boot Manager compares pl_version in both places to make sure that
-# the right CD is mounted. We used to boot from an initrd and mount
-# the CD on /usr. Now we just run everything out of the initrd.
-for file in $overlay/pl_version $overlay/usr/isolinux/pl_version ; do
-    mkdir -p $(dirname $file)
-    echo "$FULL_VERSION_STRING" >$file
-done
-
-# Install boot server configuration files
-echo "* Installing boot server configuration files"
-
-# We always intended to bring up and support backup boot servers,
-# but never got around to it. Just install the same parameters for
-# both for now.
-for dir in $overlay/usr/boot $overlay/usr/boot/backup ; do
-    install -D -m 644 $PLC_BOOT_CA_SSL_CRT $dir/cacert.pem
-    install -D -m 644 $PLC_ROOT_GPG_KEY_PUB $dir/pubring.gpg
-    echo "$PLC_BOOT_HOST" >$dir/boot_server
-    echo "$PLC_BOOT_SSL_PORT" >$dir/boot_server_port
-    echo "/boot/" >$dir/boot_server_path
-done
-
-# (Deprecated) Install old-style boot server configuration files
-install -D -m 644 $PLC_BOOT_CA_SSL_CRT $overlay/usr/bootme/cacert/$PLC_BOOT_HOST/cacert.pem
-echo "$FULL_VERSION_STRING" >$overlay/usr/bootme/ID
-echo "$PLC_BOOT_HOST" >$overlay/usr/bootme/BOOTSERVER
-echo "$PLC_BOOT_HOST" >$overlay/usr/bootme/BOOTSERVER_IP
-echo "$PLC_BOOT_SSL_PORT" >$overlay/usr/bootme/BOOTPORT
-
-# Generate /etc/issue
-echo "* Generating /etc/issue"
-
-if [ "$PLC_WWW_PORT" = "443" ] ; then
-    PLC_WWW_URL="https://$PLC_WWW_HOST/"
-elif [ "$PLC_WWW_PORT" != "80" ] ; then
-    PLC_WWW_URL="http://$PLC_WWW_HOST:$PLC_WWW_PORT/"
-else
-    PLC_WWW_URL="http://$PLC_WWW_HOST/"
-fi
-
-mkdir -p $overlay/etc
-cat >$overlay/etc/issue <<EOF
+#################### run once : build the overlay image
+function build_overlay () {
+
+    BUILDTMP=$(mktemp -d ${BUILDTMP}/bootcd.XXXXXX)
+    push_cleanup rm -fr "${BUILDTMP}"
+    mkdir "${BUILDTMP}/isofs"
+    for i in "$ISOREF"/isofs/{bootcd.img,kernel}; do
+       ln -s "$i" "${BUILDTMP}/isofs"
+    done
+    # the syslinux that comes with f12 has this file in a new location
+    cp "/usr/lib/syslinux/isolinux.bin" "${BUILDTMP}/isofs" \
+       || cp "/usr/share/syslinux/isolinux.bin" "${BUILDTMP}/isofs" 
+    ISOFS="${BUILDTMP}/isofs"
+
+    # Root of the ISO and USB images
+    echo "* Populating root filesystem..."
+    OVERLAY="${BUILDTMP}/overlay"
+    install -d -m 755 $OVERLAY
+    push_cleanup rm -fr $OVERLAY
+
+    # Create version files
+    echo "* Creating version files"
+
+    # Boot Manager compares pl_version in both places to make sure that
+    # the right CD is mounted. We used to boot from an initrd and mount
+    # the CD on /usr. Now we just run everything out of the initrd.
+    for file in $OVERLAY/pl_version $OVERLAY/usr/isolinux/pl_version ; do
+       mkdir -p $(dirname $file)
+       echo "$FULL_VERSION_STRING" >$file
+    done
+
+    # Install boot server configuration files
+    echo "* Installing boot server configuration files"
+
+    # We always intended to bring up and support backup boot servers,
+    # but never got around to it. Just install the same parameters for
+    # both for now.
+    for dir in $OVERLAY/usr/boot $OVERLAY/usr/boot/backup ; do
+       install -D -m 644 $PLC_BOOT_CA_SSL_CRT $dir/cacert.pem
+       install -D -m 644 $PLC_ROOT_GPG_KEY_PUB $dir/pubring.gpg
+       echo "$PLC_BOOT_HOST" >$dir/boot_server
+       echo "$PLC_BOOT_SSL_PORT" >$dir/boot_server_port
+       echo "/boot/" >$dir/boot_server_path
+    done
+
+    # Install old-style boot server configuration files
+    # as opposed to what a former comment suggested, 
+    # this is still required, somewhere in the bootmanager apparently
+    install -D -m 644 $PLC_BOOT_CA_SSL_CRT $OVERLAY/usr/bootme/cacert/$PLC_BOOT_HOST/cacert.pem
+    echo "$FULL_VERSION_STRING" >$OVERLAY/usr/bootme/ID
+    echo "$PLC_BOOT_HOST" >$OVERLAY/usr/bootme/BOOTSERVER
+    echo "$PLC_BOOT_HOST" >$OVERLAY/usr/bootme/BOOTSERVER_IP
+    echo "$PLC_BOOT_SSL_PORT" >$OVERLAY/usr/bootme/BOOTPORT
+
+    # Generate /etc/issue
+    echo "* Generating /etc/issue"
+
+    if [ "$PLC_WWW_PORT" = "443" ] ; then
+       PLC_WWW_URL="https://$PLC_WWW_HOST/"
+    elif [ "$PLC_WWW_PORT" != "80" ] ; then
+       PLC_WWW_URL="http://$PLC_WWW_HOST:$PLC_WWW_PORT/"
+    else
+       PLC_WWW_URL="http://$PLC_WWW_HOST/"
+    fi
+
+    mkdir -p $OVERLAY/etc
+    cat >$OVERLAY/etc/issue <<EOF
 $FULL_VERSION_STRING
 $PLC_NAME Node: \n
 Kernel \r on an \m
@@ -227,62 +304,73 @@ password of the default $PLC_NAME Central administrator account at the
 time that this CD was created.
 
 EOF
-
-# Set root password
-echo "* Setting root password"
-
-if [ -z "$ROOT_PASSWORD" ] ; then
-    # Generate an encrypted password with crypt() if not defined
-    # in a static configuration.
-    ROOT_PASSWORD=$(python <<EOF
+    
+    # Set root password
+    echo "* Setting root password"
+
+    if [ -z "$ROOT_PASSWORD" ] ; then
+        # Generate an encrypted password with crypt() if not defined
+        # in a static configuration.
+       ROOT_PASSWORD=$(python <<EOF
 import crypt, random, string
 salt = [random.choice(string.letters + string.digits + "./") for i in range(0,8)]
 print crypt.crypt('$PLC_ROOT_PASSWORD', '\$1\$' + "".join(salt) + '\$')
 EOF
 )
-fi
+    fi
 
-# build/passwd copied out by prep.sh
-sed -e "s@^root:[^:]*:\(.*\)@root:$ROOT_PASSWORD:\1@" build/passwd \
-    >$overlay/etc/passwd
+    # build/passwd copied out by prep.sh
+    sed -e "s@^root:[^:]*:\(.*\)@root:$ROOT_PASSWORD:\1@" ${VARIANT}/passwd >$OVERLAY/etc/passwd
 
-# Install node configuration file (e.g., if node has no floppy disk or USB slot)
-if [ -f "$NODE_CONFIGURATION_FILE" ] ; then
-    echo "* Installing node configuration file"
-    install -D -m 644 $NODE_CONFIGURATION_FILE $overlay/usr/boot/plnode.txt
-fi
+    # Install node configuration file (e.g., if node has no floppy disk or USB slot)
+    if [ -f "$NODE_CONFIGURATION_FILE" ] ; then
+       echo "* Installing node configuration file $NODE_CONFIGURATION_FILE -> /usr/boot/plnode.txt of the bootcd image"
+       install -D -m 644 $NODE_CONFIGURATION_FILE $OVERLAY/usr/boot/plnode.txt
+       NODE_ID=$(source $NODE_CONFIGURATION_FILE; echo $NODE_ID)
+       echo "* Building network configuration for $NODE_ID"
+       plnet -- --root $OVERLAY --files-only --program BootCD $NODE_ID
+    fi
 
-# Pack overlay files into a compressed archive
-echo "* Compressing overlay image"
-(cd $overlay && find . | cpio --quiet -c -o) | gzip -9 >$isofs/overlay.img
+    if [ -n "$IS_SERIAL" ] ; then
+       KARGS_STR="$KARGS_STR ${console_spec}"
+    fi
 
-rm -rf $overlay
-pop_cleanup
+    if [ -n "$KARGS_STR" ] ; then
+       echo "$KARGS_STR" > $OVERLAY/kargs.txt
+       kernel_args=$KARGS_STR
+    fi
 
-if [ -n "$CUSTOM_DIR" ]; then
-    echo "* Compressing custom image"
-    (cd "$CUSTOM_DIR" && find . | cpio --quiet -c -o) | gzip -9 >$isofs/custom.img
-fi
+    # Pack overlay files into a compressed archive
+    echo "* Compressing overlay image"
+    (cd $OVERLAY && find . | cpio --quiet -c -o) | gzip -9 >$ISOFS/overlay.img
 
-# Calculate ramdisk size (total uncompressed size of both archives)
-ramdisk_size=$(gzip -l $isofs/bootcd.img $isofs/overlay.img ${CUSTOM_DIR:+$isofs/custom.img} | tail -1 | awk '{ print $2; }') # bytes
-ramdisk_size=$((($ramdisk_size + 1023) / 1024)) # kilobytes
+    rm -rf $OVERLAY
+    pop_cleanup
 
-echo "$FULL_VERSION_STRING" >$isofs/pl_version
+    if [ -n "$CUSTOM_DIR" ]; then
+       echo "* Compressing custom image"
+       (cd "$CUSTOM_DIR" && find . | cpio --quiet -c -o) | gzip -9 >$ISOFS/custom.img
+    fi
 
-popd
+    # Calculate ramdisk size (total uncompressed size of both archives)
+    ramdisk_size=$(gzip -l $ISOFS/bootcd.img $ISOFS/overlay.img ${CUSTOM_DIR:+$ISOFS/custom.img} | tail -1 | awk '{ print $2; }') # bytes
+    ramdisk_size=$((($ramdisk_size + 1023) / 1024)) # kilobytes
 
-function build_iso()
-{
-    local iso="$1"
-    local serial=$2
-    local custom=$3
+    echo "$FULL_VERSION_STRING" >$ISOFS/pl_version
+
+    popd
+}
+
+#################### plain ISO
+function build_iso() {
+    local iso="$1" ; shift
+    local custom="$1"
 
     # Write isolinux configuration
-    cat >$isofs/isolinux.cfg <<EOF
-${serial:+SERIAL 0 115200}
+    cat >$ISOFS/isolinux.cfg <<EOF
+${console_serial_line}
 DEFAULT kernel
-APPEND ramdisk_size=$ramdisk_size initrd=bootcd.img,overlay.img${custom:+,custom.img} root=/dev/ram0 rw ${serial:+console=ttyS0,115200n8}
+APPEND ramdisk_size=$ramdisk_size initrd=bootcd.img,overlay.img${custom:+,custom.img} root=/dev/ram0 rw ${kernel_args}
 DISPLAY pl_version
 PROMPT 0
 TIMEOUT 40
@@ -290,31 +378,92 @@ EOF
 
     # Create ISO image
     echo "* Creating ISO image"
-    mkisofs -o "$iso" \
-        $MKISOFS_OPTS \
-        $isofs
+    mkisofs -o "$iso" $MKISOFS_OPTS $ISOFS
+}
+
+#################### USB with partitions
+function build_usb_partition() {
+    echo -n "* Creating USB image with partitions..."
+    local usb="$1" ; shift
+    local custom="$1"
+
+    local size=$(($(du -Lsk $ISOFS | awk '{ print $1; }') + $FREE_SPACE))
+    size=$(( $size / 1024 ))
+
+    local heads=64
+    local sectors=32
+    local cylinders=$(( ($size*1024*2)/($heads*$sectors) ))
+    local offset=$(( $sectors*512 ))
+
+    if [ -f  /usr/lib/syslinux/mkdiskimage ] ; then
+        /usr/lib/syslinux/mkdiskimage -M -4 "$usb" $size $heads $sectors
+    else
+        mkdiskimage -M -4 "$usb" $size $heads $sectors
+    fi
+
+    cat >${BUILDTMP}/mtools.conf<<EOF
+drive z:
+file="${usb}"
+cylinders=$cylinders
+heads=$heads
+sectors=$sectors
+offset=$offset
+mformat_only
+mtools_skip_check=1
+EOF
+    # environment variable for mtools
+    export MTOOLSRC="${BUILDTMP}/mtools.conf"
+
+    ### COPIED FROM build_usb() below!!!!
+    echo -n " populating USB image... "
+    mcopy -bsQ -i "$usb" "$ISOFS"/* z:/
+       
+    # Use syslinux instead of isolinux to make the image bootable
+    tmp="${BUILDTMP}/syslinux.cfg"
+    cat >$tmp <<EOF
+${console_serial_line}
+DEFAULT kernel
+APPEND ramdisk_size=$ramdisk_size initrd=bootcd.img,overlay.img${custom:+,custom.img} root=/dev/ram0 rw ${kernel_args}
+DISPLAY pl_version
+PROMPT 0
+TIMEOUT 40
+EOF
+    mdel -i "$usb" z:/isolinux.cfg 2>/dev/null || :
+    mcopy -i "$usb" "$tmp" z:/syslinux.cfg
+    rm -f "$tmp"
+    rm -f "${MTOOLSRC}"
+    unset MTOOLSRC
+
+    echo "making USB image bootable."
+    syslinux -o $offset "$usb"
+
 }
 
-# Create USB image
-function build_usb()
-{
+#################### plain USB
+function build_usb() {
     echo -n "* Creating USB image... "
-    local usb="$1"
-    local serial=$2
-    local custom=$3
+    local usb="$1" ; shift
+    local custom="$1"
+
+    rm -f "$usb"
+    mkfs.vfat -C "$usb" $(($(du -Lsk $ISOFS | awk '{ print $1; }') + $FREE_SPACE))
 
-    mkfs.vfat -C "$usb" $(($(du -Lsk $isofs | awk '{ print $1; }') + $FREE_SPACE))
+    cat >${BUILDTMP}/mtools.conf<<EOF
+mtools_skip_check=1
+EOF
+    # environment variable for mtools
+    export MTOOLSRC="${BUILDTMP}/mtools.conf"
 
     # Populate it
     echo -n " populating USB image... "
-    mcopy -bsQ -i "$usb" "$isofs"/* ::/
+    mcopy -bsQ -i "$usb" "$ISOFS"/* ::/
 
     # Use syslinux instead of isolinux to make the image bootable
     tmp="${BUILDTMP}/syslinux.cfg"
     cat >$tmp <<EOF
-${serial:+SERIAL 0 115200}
+${console_serial_line}
 DEFAULT kernel
-APPEND ramdisk_size=$ramdisk_size initrd=bootcd.img,overlay.img${custom:+,custom.img} root=/dev/ram0 rw ${serial:+console=ttyS0,115200n8}
+APPEND ramdisk_size=$ramdisk_size initrd=bootcd.img,overlay.img${custom:+,custom.img} root=/dev/ram0 rw ${kernel_args}
 DISPLAY pl_version
 PROMPT 0
 TIMEOUT 40
@@ -322,27 +471,27 @@ EOF
     mdel -i "$usb" ::/isolinux.cfg 2>/dev/null || :
     mcopy -i "$usb" "$tmp" ::/syslinux.cfg
     rm -f "$tmp"
+    rm -f "${MTOOLSRC}"
+    unset MTOOLSRC
 
     echo "making USB image bootable."
     syslinux "$usb"
 }
 
-
-# Setup CRAMFS related support
-function prepare_cramfs()
-{
+#################### utility to setup CRAMFS related support
+function prepare_cramfs() {
     [ -n "$CRAMFS_PREPARED" ] && return 0
-    local custom=$1
+    local custom=$1; 
 
     echo "* Setting up CRAMFS-based images"
     local tmp="${BUILDTMP}/cramfs-tree"
     mkdir -p "$tmp"
     push_cleanup rm -rf $tmp
     pushd $tmp
-    gzip -d -c $isofs/bootcd.img     | cpio -diu
-    gzip -d -c $isofs/overlay.img    | cpio -diu
+    gzip -d -c $ISOFS/bootcd.img     | cpio -diu
+    gzip -d -c $ISOFS/overlay.img    | cpio -diu
     [ -n "$custom" ] && \
-        gzip -d -c $isofs/custom.img | cpio -diu
+        gzip -d -c $ISOFS/custom.img | cpio -diu
 
     # clean out unnecessary rpm lib
     echo "* clearing var/lib/rpm/*"
@@ -397,23 +546,32 @@ EOF
     popd
 
     # update etc/inittab to start with pl_rsysinit
-    sed -i 's,pl_sysinit,pl_rsysinit,' etc/inittab
+    for file in etc/inittab etc/event.d/rcS etc/init/rcS.conf; do
+       [ -f $file ] && sed -i 's,pl_sysinit,pl_rsysinit,' $file
+    done
 
     # modify inittab to have a serial console
-    echo "T0:23:respawn:/sbin/agetty -L ttyS0 9600 vt100" >> etc/inittab
-    # and let root log in
-    echo "ttyS0" >> etc/securetty
+    # xxx this might well be broken with f12 and above xxx
+    if [ -n "$serial" ] ; then
+       echo "T0:23:respawn:/sbin/agetty -L $console_dev $console_baud vt100" >> etc/inittab
+        # and let root log in
+       echo "$console_dev" >> etc/securetty
+    fi
 
     # calculate the size of /tmp based on the size of /etc & /var + 8MB slack
     etcsize=$(du -s ./etc | awk '{ print $1 }')
     varsize=$(du -s ./var | awk '{ print $1 }')
     let msize=($varsize+$etcsize+8192)/1024
 
+    # make dhclient happy
+    for i in $(seq 0 9); do ln -fs /tmp/etc/dhclient-eth${i}.conf etc/dhclient-eth${i}.conf ; done
+    ln -fs /tmp/etc/resolv.conf etc/resolv.conf
+    ln -fs /tmp/etc/resolv.conf.predhclient etc/resolv.conf.predhclient
 
     # generate pl_rsysinit
     cat > etc/rc.d/init.d/pl_rsysinit <<EOF
 #!/bin/sh
-# generated by build.sh
+# generated by $COMMAND
 echo -n "pl_rsysinit: preparing /etc and /var for pl_sysinit..."
 mount -t tmpfs -orw,size=${msize}M,mode=1777 tmpfs /tmp
 mkdir -p /tmp/root
@@ -435,6 +593,7 @@ for odir in \$(cd /var && ls -d *_o); do dir=\$(echo \$odir | sed 's,\_o$,,'); (
 popd
 
 echo "done"
+
 # hand over to pl_sysinit
 echo "pl_rsysinit: handing over to pl_sysinit"
 /etc/init.d/pl_sysinit
@@ -451,22 +610,22 @@ EOF
     pop_cleanup
 }
 
-# Create ISO CRAMFS image
-function build_iso_cramfs()
-{
-    local iso="$1"
-    local serial=$2
-    prepare_cramfs $3
+#################### Create ISO CRAMFS image
+function build_iso_cramfs() {
+    local iso="$1" ; shift
+    local custom="$1"
+
+    prepare_cramfs "$custom"
     echo "* Creating ISO CRAMFS-based image"
 
     local tmp="${BUILDTMP}/cramfs-iso"
     mkdir -p "$tmp"
     push_cleanup rm -rf $tmp
-    (cd $isofs && find . | grep -v "\.img$" | cpio -p -d -u $tmp/)
+    (cd $ISOFS && find . | grep -v "\.img$" | cpio -p -d -u $tmp/)
     cat >$tmp/isolinux.cfg <<EOF
-${serial:+SERIAL 0 9600}
+${console_serial_line}
 DEFAULT kernel
-APPEND ramdisk_size=$cramfs_size initrd=cramfs.img root=/dev/ram0 ro ${serial:+console=ttyS0,9600n8}
+APPEND ramdisk_size=$cramfs_size initrd=cramfs.img root=/dev/ram0 ro ${kernel_args}
 DISPLAY pl_version
 PROMPT 0
 TIMEOUT 40
@@ -474,19 +633,19 @@ EOF
 
     cp ${BUILDTMP}/cramfs.img $tmp
     mkisofs -o "$iso" \
-        "$MKISOFS_OPTS" \
+        $MKISOFS_OPTS \
         $tmp
 
     rm -fr "$tmp"
     pop_cleanup
 }
 
-# Create USB CRAMFS based image
-function build_usb_cramfs()
-{
-    local usb="$1"
-    local serial=$2
-    prepare_cramfs $3
+#################### Create USB CRAMFS based image
+function build_usb_cramfs() {
+    local usb="$1" ; shift
+    local custom="$1"
+
+    prepare_cramfs "$custom"
     echo "* Creating USB CRAMFS based image"
 
     let vfat_size=${cramfs_size}+$FREE_SPACE
@@ -496,19 +655,20 @@ function build_usb_cramfs()
 
     # Populate it
     echo "* Populating USB with overlay images and cramfs"
-    mcopy -bsQ -i "$usb" $isofs/kernel $isofs/pl_version ::/
+    mcopy -bsQ -i "$usb" $ISOFS/kernel $ISOFS/pl_version ::/
     mcopy -bsQ -i "$usb" ${BUILDTMP}/cramfs.img ::/
 
     # Use syslinux instead of isolinux to make the image bootable
     tmp="${BUILDTMP}/syslinux.cfg"
     cat >$tmp <<EOF
-${serial:+SERIAL 0 9600}
+${console_serial_line}
 DEFAULT kernel
-APPEND ramdisk_size=$cramfs_size initrd=cramfs.img root=/dev/ram0 ro ${serial:+console=ttyS0,9600n8}
+APPEND ramdisk_size=$cramfs_size initrd=cramfs.img root=/dev/ram0 ro ${kernel_args}
 DISPLAY pl_version
 PROMPT 0
 TIMEOUT 40
 EOF
+
     mcopy -bsQ -i "$usb" "$tmp" ::/syslinux.cfg
     rm -f "$tmp"
 
@@ -516,30 +676,67 @@ EOF
     syslinux "$usb"
 }
 
-function type_to_name()
-{
-    echo $1 | sed '
+#################### map on all types provided on the command-line and invoke one of the above functions
+function build_types () {
+
+    [ -z "$OUTPUT_BASE" ] && OUTPUT_BASE="$PLC_NAME-BootCD-$BOOTCD_VERSION"
+
+    # alter output filename to reflect serial settings
+    if [ -n "$IS_SERIAL" ] ; then
+       if [ "$CONSOLE_INFO" == "$SERIAL_CONSOLE" ] ; then
+           serial="-serial"
+       else
+           serial="-serial-$(echo $CONSOLE_INFO | sed -e 's,:,,g')"
+       fi
+    else
+       serial=""
+    fi
+    
+    function type_to_name() {
+       echo $1 | sed '
         s/usb$/.usb/;
-        s/usb_serial$/-serial.usb/;
+        s/usb_partition$/-partition.usb/;
         s/iso$/.iso/;
-        s/iso_serial$/-serial.iso/;
         s/usb_cramfs$/-cramfs.usb/;
-        s/usb_cramfs_serial$/-cramfs-serial.usb/;
         s/iso_cramfs$/-cramfs.iso/;
-        s/iso_cramfs_serial$/-cramfs-serial.iso/;
         '
+    }
+
+    for t in $TYPES; do
+       arg=$t
+
+       tname=`type_to_name $t`
+        # if -o is specified (as it has no default)
+       if [ -n "$OUTPUT_NAME" ] ; then
+           output=$OUTPUT_NAME
+       else
+           output="${OUTPUT_BASE}${serial}${tname}"
+       fi
+
+       echo "*** Dealing with type=$arg"
+       echo '*' build_$t "$output" "$CUSTOM_DIR"
+       [ -n "$DRY_RUN" ] || build_$t "$output" "$CUSTOM_DIR" 
+    done
 }
 
-[ -z "$OUTPUT_BASE" ] && OUTPUT_BASE="$PLC_NAME-BootCD-$BOOTCD_VERSION"
+#################### 
+function main () {
 
-for t in $TYPES; do
-    serial=
-    tname=`type_to_name $t`
-    if [[ "$t" == *_serial ]]; then
-        serial=1
-        t=`echo $t | sed 's/_serial$//'`
-    fi
-    build_$t "${OUTPUT_BASE}${tname}" $serial $CUSTOM_DIR
-done
+    parse_command_line "$@"
+
+    init_and_check
+
+    echo "* Building images for $FULL_VERSION_STRING"
+    # Do not tolerate errors
+    set -e
+    trap "do_cleanup" ERR INT EXIT
+
+    init_serial $CONSOLE_INFO
+    build_overlay
+    build_types
+
+    exit 0
+}
 
-exit 0
+####################
+main "$@"